<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" size="mini" label-width="100px" v-show="showSearch">
        <el-row>
          <el-col :span="8">
            <el-form-item class="query-form-item" label="预验收单号:">
              <el-input v-model="filterQuery.billNo" placeholder="单号"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>

        </el-row>
      </el-form>
      <div class="top-right-btn">
        <el-button-group>
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button
            type="primary"
            icon="el-icon-refresh"
            @click="onReset"
          >重置
          </el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmit"
          >查询
          </el-button
          >
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>
      <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row
                border
                @current-change="handleSelectionChange">
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="单据号" prop="billNo" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源" prop="fromType">
          <template slot-scope="scope">
            <span>{{ fromTypeMap[scope.row.orderFromType] }}</span>
          </template>
        </el-table-column>
        <el-table-column label="往来单位" prop="fromCorpName" width="220">
        </el-table-column>
        <el-table-column label="当前部门" prop="deptName" width="120">
        </el-table-column>
        <el-table-column label="当前仓库" prop="invName" width="120">
        </el-table-column>
        <el-table-column label="创建时间" prop="createTime" show-overflow-tooltip>
          <template slot-scope="scope">
            <i class="el-icon-time"></i>
            <span>{{ scope.row.createTime }}</span>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :limit.sync="filterQuery.limit"
        :page.sync="filterQuery.page"
        @pagination="getList"
      ></pagination>
    </el-card>

    <el-tabs type="border-card" style="margin: 15px">
      <!--单据扫码明细-->
      <el-tab-pane>
        <span slot="label">预验收库存详情</span>
        <el-form :model="codeQuery" class="query-form" size="mini" label-width="100px">

          <el-row>
            <el-col :span="11">
              <el-form-item class="query-form-item" label="UDI码:">
                <el-input
                  v-model="codeQuery.code"
                  placeholder="请输入UDI码"
                  clearable
                >
                </el-input>
              </el-form-item>
            </el-col>
            <el-col :span="11">
              <el-form-item>
                <el-button-group>
                  <el-button
                    type="primary"
                    icon="el-icon-refresh"
                    @click="onCodeReset"
                  >重置
                  </el-button>
                  <el-button type="primary" @click="onCodeSubmit"
                             icon="el-icon-search"
                  >查询
                  </el-button
                  >
                </el-button-group>
              </el-form-item>
            </el-col>
          </el-row>


        </el-form>

        <el-table v-loading="codeDetailLoading" :data="codeDetailList" style="width: 100%" border
                  row-key="id"
        >
          <el-table-column label="序号" type="index"></el-table-column>
          <el-table-column
            label="UDI码"
            prop="code"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="产品名称"
            prop="productName"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="生产日期"
            prop="produceDate"
            width="120"
          ></el-table-column>
          <el-table-column
            label="失效日期"
            prop="expireDate"
            width="120"
          ></el-table-column>
          <el-table-column
            label="批次号"
            prop="batchNo"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="序列号"
            prop="serialNo"
          ></el-table-column>
          <el-table-column
            label="扫码数量"
            prop="reCount"
          ></el-table-column>
          <el-table-column
            label="实际数量"
            prop="reCount"
          ></el-table-column>
        </el-table>
        <pagination
          v-show="codeTotal>0"
          :total="codeTotal"
          :page.sync="codeQuery.page"
          :limit.sync="codeQuery.limit"
          @pagination="getCodeDetailList"
        />
      </el-tab-pane>
    </el-tabs>

  </div>
</template>

<script>
import {
  deleterPrein,
  filterPrein, filterDetail
} from "@/api/inventory/invPreInSearch";
import {getLocalJoinByUser} from "@/api/basic/busType";
import {isBlank} from "@/utils/strUtil";
import {getBasicUnitMaintains} from "@/api/basic/basicUnitMaintain";
import store from "@/store";


const formJson = {
  site_id: "",
  site_name: "",
  describe: "",
  ads: [],
};

export default {
  name: "InvPreInSerach",
  data() {
    return {
      showSearch: true,
      filterQuery: {
        id: "",
        billNo: null,
        page: 1,
        limit: 10,
        startTime: null,
        endTime: null,
      },
      invList: [],
      list: [],
      total: 0,
      loading: false,
      index: null,
      enableDept: false,
      fromTypeMap: {
        "1": "UDIMS平台",
        "2": "网页新增",
        "3": "pda即时校验",
        "4": "pda未校验",
        "5": "pc端扫码精灵",
        "6": "缺量补录单据",
        "7": "UDI供应商平台",
        "8": "平衡补录单据",
        "10": "手动补单",
        "11": "仓库盘点",
        "12": "采购计划",
        "13": "领用单据",
        "14": "第三方系统单据",
      },
      deleteData: {
        orderId: null,
      },
      dialogTableVisible: false,
      formLoading: false,
      dialogVisible: false,
      formData: formJson,
      deleteLoading: false,
      busTypes: [],
      currentRow: {},
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      codeQuery: {
        orderId: null,
        page: 1,
        limit: 10
      },
      codeTotal: 0,
      codeDetailLoading: false,
      codeDetailList: [],
      fromOptions: [],
    };
  },
  components: {},
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        id: "",
        billNo: null,
        page: 1,
        limit: 10,
        startTime: null,
        endTime: null,
      };
      this.getList();
    },
    onSubmit() {
      this.loading = true;
      if (this.actDateRange !== null) {
        this.filterQuery.startTime = this.actDateRange[0];
        this.filterQuery.endTime = this.actDateRange[1];
      } else {
        this.filterQuery.startTime = null;
        this.filterQuery.endTime = null;
      }
      this.filterQuery.page = 1;

      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    getBusType() {
      let query = {
        code: this.filterQuery.invCode,
        enabled: true,
      };
      getLocalJoinByUser(query)
        .then((response) => {
          this.busTypes = response.data.list || [];
          this.filterQuery.action = this.busTypes[0].action;
        })
        .catch(() => {
        });
    },
    handleSelectionChange(val) {
      this.currentRow = val;
      this.getOrderDetails();
    },

    getOrderDetails() {
      this.codeQuery.page = 1;
      this.getCodeDetailList();
    },
    clearDetailList() {
      this.codeDetailList = [];
      this.codeTotal = 0;
    },
    //获取订单列表
    getList() {
      this.loading = true;
      this.currentRow = {billNo: ""};
      this.clearDetailList();
      this.filterQuery.fromCorp = store.getters.customerId
      filterPrein(this.filterQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
        })
        .catch((error) => {
          this.$message.error(error.message)
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    deleteOrders(data) {
      this.loading = true;
      let delQuery = {
        billNo: data,
      }
      deleterPrein(delQuery)
        .then((response) => {

          if (response.code == 20000) {
            this.getList();
            this.$message({
              type: "success",
              message: "删除成功！",
            });
          } else if (response.code == 520) {
            this.$message.error("新增扫码单据列表已不存在该扫码单据！");
            this.getList();
          }

        })
        .catch(() => {
        });
    },
    deleteDialog(row) {
      this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.deleteOrders(row.billNo);
        })
        .catch(() => {
        });
    },
    onCodeReset() {
      this.codeQuery = {
        orderIdFk: null,
        page: 1,
        limit: 10
      };
      this.getCodeDetailList();
    },
    onCodeSubmit() {
      this.codeQuery.page = 1;
      this.getCodeDetailList();
    },
    getCodeDetailList() {
      if (isBlank(this.currentRow.billNo)) {
        this.$message.error("请先选择需要查询的单据！")
        return;
      }

      this.codeQuery.orderId = this.currentRow.billNo;
      this.codeDetailLoading = true;
      filterDetail(this.codeQuery).then((res) => {
        this.codeDetailLoading = false;
        if (res.code === 20000) {
          this.codeDetailList = res.data.list || [];
          this.codeTotal = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.codeDetailList = [];
          this.codeTotal = 0;
        }
      }).catch((error) => {
        this.codeDetailLoading = true;
        this.$message.error(error.message);
        this.codeDetailList = [];
        this.codeTotal = 0;
      })
    },

    findMethod(query) {
      this.fromOptions = [];
      let cQuery = {
        key: query,
        corpType: 2,
        page: 1,
        limit: 10,
      };
      getBasicUnitMaintains(cQuery)
        .then((response) => {
          this.loading = false;
          this.fromOptions = response.data.list || [];
        })
        .catch(() => {
          this.loading = false;
          this.fromOptions = [];
        });
    },

  },
  filters: {
    statusFilterType(status) {
      const statusMap = {
        false: "success",
        true: "warning",
      };
      return statusMap[status];
    },
  },
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  },
  created() {
    this.getList();
  },
};
</script>

<style type="text/scss" lang="scss">
</style>
